#NoTrayIcon
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <WindowsConstants.au3>
#include <GuiEdit.au3>
#include <GuiTab.au3>
#include <GuiToolTip.au3>
#include <isnautoitstudio_plugin.au3>

Global $input_file_open, $input_website, $input_website_post, $tab_select
Global $input_regex, $input_replace, $edit_textToCheck, $edit_matches
Global $tab, $radio_state, $tabstate, $radio[3]

Global $font_size = 8.5
Global $font_weight = 550
Global $font_name = "Verdana"
Global $program_name = "Regex Toolkit"

_Main()

Func _Main()
	Local $resultHolder, $webinput, $check_regex, $check_www, $ChecktextToCheck, $check_replace
	Local $postinput, $radio_state_check, $msgbox
	
	Local $file_type = IniRead(@ScriptDir & "\plugin.ini", "plugin", "filetypes", "inx")
	
	Local $gui = GUICreate("", 1080, 525, -1,-1, $WS_POPUP, BitOr($WS_EX_CLIENTEDGE, $WS_EX_TOOLWINDOW, $WS_EX_ACCEPTFILES))

	GUICtrlCreateGroup("", 10, 5, 110, 90)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)

	$radio[0] = GUICtrlCreateRadio(_ISNPlugin_Get_langstring(1), 15, 18, 100, 20); Match
	GUICtrlSetResizing(-1, $GUI_DOCKTOP +  $GUI_DOCKHEIGHT)
	GUICtrlSetCursor(-1, 0)
	$radio[1] = GUICtrlCreateRadio(_ISNPlugin_Get_langstring(2), 15, 43, 100, 20); Array of matches
	GUICtrlSetResizing(-1, $GUI_DOCKTOP +  $GUI_DOCKHEIGHT)
	GUICtrlSetCursor(-1, 0)
	$radio[2] = GUICtrlCreateRadio(_ISNPlugin_Get_langstring(3), 15, 68, 100, 20); Match and replace
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
	GUICtrlSetCursor(-1, 0)

	$tab = GUICtrlCreateTab(130, 10, 615, 85)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	

	Local $tab_website = GUICtrlCreateTabitem(_ISNPlugin_Get_langstring(4)); Insert website data
	GUICtrlSetImage(-1, "shell32.dll", -14, 0)
	Local $label_website = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(5), 140, 42, 70, 17); Website URL
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	$input_website = GUICtrlCreateInput("", 220, 40, 516, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	Local $label_website_post = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(6), 140, 67, 60, 17); POST
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	$input_website_post = GUICtrlCreateInput("", 220, 65, 516, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	

	Local $tab_file = GUICtrlCreateTabitem(_ISNPlugin_Get_langstring(7)); Insert file data
	GUICtrlSetImage(-1, "shell32.dll", -55, 0)
	Local $label_file_open = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(8), 140, 42, 65, 17); File open
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	$input_file_open = GUICtrlCreateInput("", 220, 40, 381, 20)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	Local $Button_file_open = GUICtrlCreateButton(_ISNPlugin_Get_langstring(9), 605, 40, 130, 20); Browse
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	GUICtrlSetCursor(-1, 0)

	Local $tab_clear = GUICtrlCreateTabitem(_ISNPlugin_Get_langstring(10)); Clear fields
	GUICtrlSetImage(-1, "shell32.dll", -110, 0)
	Local $button_clear_all = GUICtrlCreateButton(_ISNPlugin_Get_langstring(11), 140, 40, 130, 20); Clear all fields
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	GUICtrlSetCursor(-1, 0)
	Local $button_clear_website = GUICtrlCreateButton(_ISNPlugin_Get_langstring(12), 140, 65, 130, 20); Clear website fields
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	GUICtrlSetCursor(-1, 0)
	Local $button_clear_file = GUICtrlCreateButton(_ISNPlugin_Get_langstring(13), 275, 40, 130, 20); Clear file fields
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	GUICtrlSetCursor(-1, 0)

	Local $tab_export = GUICtrlCreateTabitem(_ISNPlugin_Get_langstring(14)); Load and Save settings
	GUICtrlSetImage(-1, "shell32.dll", -4, 0)
	Local $button_export = GUICtrlCreateButton(_ISNPlugin_Get_langstring(15), 140, 40, 130, 20); Save settings
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
	GUICtrlSetCursor(-1, 0)
	Local $button_import = GUICtrlCreateButton(_ISNPlugin_Get_langstring(16), 140, 65, 130, 20); Load settings
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
	GUICtrlSetCursor(-1, 0)

	Local $label_draganddrop = GUICtrlCreateLabel($file_type & " " & _ISNPlugin_Get_langstring(37), 360, 40, 285, 20, $SS_CENTER); file can be drag and droped to load settings
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)
	
	Local $tab_code = GUICtrlCreateTabitem(_ISNPlugin_Get_langstring(38)); Create AutoIt Code
	GUICtrlSetImage(-1, "shell32.dll", -71, 0)
	
	GUICtrlCreateTabitem("")

	GUICtrlCreateGroup("", 10, 105, 733, 70)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	Local $label_regex = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(18), 15, 122, 50, 17); Regex
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)

	$input_regex = GUICtrlCreateInput("", 80, 120, 656, 21)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	

	Local $label_replace = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(19), 15, 147, 50, 17); Replace
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	$input_replace = GUICtrlCreateInput("", 80, 145, 656, 21)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	

	Local $label_Output = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(20), 10, 185, 415, 17); Text data
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	Local $label_found = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(21), 435, 185, 288, 17); Regular expression output data
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)	
	
	$edit_textToCheck = GUICtrlCreateEdit("", 10, 205, 415, 309)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKBOTTOM)
	$edit_matches = GUICtrlCreateEdit("", 435, 205, 308, 309)
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKBOTTOM)

	Local $edit_help = GUICtrlCreateEdit("", 755, 30, 315, 349, $ES_READONLY)
	GUICtrlSetResizing($edit_help, $GUI_DOCKTOP + $GUI_DOCKBOTTOM)	

	GUICtrlSetData($edit_help, 	_ISNPlugin_Get_langstring(22) & @CRLF & @CRLF & _; Cheat sheet:
								"abc		Letters" & @CRLF & _
								"123		Digits" & @CRLF & _
								"\d		Any Digit" & @CRLF & _
								"\D		Any Non-digit character" & @CRLF & _
								".		Any Character" & @CRLF & _
								"\.		Period" & @CRLF & _
								"[abc]		Only a, b, or c" & @CRLF & _
								"[^abc]		Not a, b, nor c" & @CRLF & _
								"[a-z]		Characters a to z" & @CRLF & _
								"[0-9]		Numbers 0 to 9" & @CRLF & _
								"\x		Represents Unicode char. from hex" & @CRLF & _
								"\w		Any Alphanumeric character" & @CRLF & _
								"\W		Any Non-alphanumeric character" & @CRLF & _
								"{m}		m Repetitions" & @CRLF & _
								"{m,n}		m to n Repetitions" & @CRLF & _
								"*		Zero or more repetitions" & @CRLF & _
								"+		One or more repetitions" & @CRLF & _
								"?		Optional character" & @CRLF & _
								"\s		Any Whitespace" & @CRLF & _
								"\S		Any Non-whitespace character" & @CRLF & _
								"^$		Starts and ends" & @CRLF & _
								"(?i)		Case-insensitive from that point on" & @CRLF & _
								"(?m)		Multi line" & @CRLF & _
								"()		Capture Group" & @CRLF & _
								"(a(bc))		Capture Sub-group" & @CRLF & _
								"(.*)		Capture all" & @CRLF & _
								"(abc|def)		Matches abc or def"); & @CRLF & @CRLF & _


	Local $label_madeby = GUICtrlCreatelabel(_ISNPlugin_Get_langstring(23), 755, 8, 315, 20, $SS_CENTER); Regex Toolkit plugin is made by Nend Software
	GUICtrlSetResizing(-1, $GUI_DOCKTOP + $GUI_DOCKHEIGHT)		

	GUICtrlCreateGroup("", 755, 389, 315, 125)
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)	
	Local $label_websites = GUICtrlCreateLabel(_ISNPlugin_Get_langstring(24), 762, 406, 295, 20); Useful Regular Expressions websites:
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)
	Local $weblink_1 = _GuiCtrlCreateHyperlink("https://regexone.com", 762, 426, 295, 20, 0x000000, "Learn Regular Expressions with simple, interactive exercises")
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)
	Local $weblink_2 = _GuiCtrlCreateHyperlink("https://regex101.com", 762, 446, 295, 20, 0x000000, "Online Regular Expresions creator")
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)
	Local $weblink_3 = _GuiCtrlCreateHyperlink("http://www.regular-expressions.info", 762, 466, 295, 20, 0x000000, "The Premier website about Regular Expressions")
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)
	Local $weblink_4 = _GuiCtrlCreateHyperlink("StringRegExp helpfile", 762, 486, 295, 20, 0x000000, "AutoIt StringRegExp helpfile")
	GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKHEIGHT)


	GUICtrlSetFont($tab, $font_size, $font_weight, Default, $font_name)
	GUICtrlSetFont($radio[0], $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($radio[1], $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($radio[2], $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($label_website, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($input_website, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($label_replace, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($label_regex, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($label_found, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($label_Output, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($label_website_post, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($input_website_post, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($label_file_open, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($input_file_open, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($Button_file_open, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($button_clear_all, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($button_clear_website, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($button_clear_file, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($button_export, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($button_import, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($label_draganddrop, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($edit_help, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($input_regex, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($input_replace, $font_size ,$font_weight, Default, $font_name)
	GUICtrlSetFont($edit_textToCheck, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetFont($label_websites, $font_size ,$font_weight + 200, Default, $font_name)
	GUICtrlSetFont($label_madeby, $font_size ,$font_weight, Default, $font_name)

	GUICtrlSetState($radio[1], $GUI_CHECKED)
	$radio_state = 1
	GUICtrlSetState($input_replace, $GUI_DISABLE)

	_ISNPlugin_initialize($Gui)
	If @error Then
		MsgBox(16, _ISNPlugin_Get_langstring(25), _ISNPlugin_Get_langstring(26)); Error  This program is part of the ISN AutoIt Studio and cannot be started separately!
		Exit ;Plugin can not start without the ISN
	EndIf

	GUICtrlSetData($input_regex, _ISNPlugin_Scintilla_Get_Selection_Text(_ISNPlugin_Get_Scintilla_Handle_from_ISN_AutoIt_Studio($Get_last_used_Scintilla_Handle))); get the selected text from the Scintilla editor

	GUIRegisterMsg(0x233, "_WM_DROPFILES_FUNC")
	GUISetState(@SW_SHOW)

	If $CmdLine[0] > 0 Then
		If FileExists($CmdLine[1]) Then
			If StringInStr($CmdLine[1], $file_type) Then
				_Import($CmdLine[1], $gui)
			EndIf
		EndIf	
	EndIf	

	While 1
		Switch GUIGetMsg()
			Case $weblink_1
				ShellExecute("https://regexone.com")
			Case $weblink_2
				ShellExecute("https://regex101.com")
			Case $weblink_3
				ShellExecute("http://www.regular-expressions.info")
			Case $weblink_4
				If FileExists(_ISNPlugin_Get_Variable_from_ISN_AutoIt_Studio("$helpfile")) Then
 					Run(_ISNPlugin_Get_Variable_from_ISN_AutoIt_Studio("$helpfile") & " StringRegExp")
 				EndIf
			Case $tab
				Switch GUICtrlRead($tab)
					Case 0
						$webinput = ""
						$tab_select = 0
					Case 1
						If GUICtrlRead($input_file_open) <> "" Then
							If FileExists(GUICtrlRead($input_file_open)) Then
								GUICtrlSetData($edit_textToCheck, FileRead(GUICtrlRead($input_file_open)))
							EndIf
						EndIf
						$tab_select = 1
					Case 2
						$tab_select = 2
					Case 3
						$tab_select = 3
					Case 4 
						_GUICtrlTab_ActivateTab($tab, $tab_select)
						_Generate_code()					
				EndSwitch
			Case $button_clear_all
				$msgbox = MsgBox(1, $program_name, _ISNPlugin_Get_langstring(27) & @CRLF & _ISNPlugin_Get_langstring(28), Default, $Gui); This will clear all fields   Do you wish to continue?
				If $msgbox = 1 Then
					GUICtrlSetData($input_website, "")
					GUICtrlSetData($input_website_post, "")
					GUICtrlSetData($input_regex, "")
					GUICtrlSetData($input_file_open, "")
					GUICtrlSetData($input_replace, "")
					GUICtrlSetData($edit_matches, "")
					GUICtrlSetData($edit_textToCheck, "")
				EndIf
			Case $button_clear_website
				$msgbox = MsgBox(1, $program_name, _ISNPlugin_Get_langstring(29) & @CRLF & _ISNPlugin_Get_langstring(28), Default, $Gui); This will clear all website fields  Do you wish to continue?
				If $msgbox = 1 Then
					GUICtrlSetData($input_website, "")
					GUICtrlSetData($input_website_post, "")
					GUICtrlSetData($edit_matches, "")
					GUICtrlSetData($edit_textToCheck, "")
				EndIf
			Case $button_clear_file
				$msgbox = MsgBox(1, $program_name, _ISNPlugin_Get_langstring(30) & @CRLF & _ISNPlugin_Get_langstring(28), Default, $Gui); This will clear the file open fields  Do you wish to continue?
				If $msgbox = 1 Then
					GUICtrlSetData($input_file_open, "")
					GUICtrlSetData($edit_matches, "")
					GUICtrlSetData($edit_textToCheck, "")
				EndIf
			Case $Button_file_open
				$file_data = FileOpenDialog(_ISNPlugin_Get_langstring(31), @ScriptDir, "(*.*)"); Load file
				If $file_data <> "" Then
					GUICtrlSetData($input_file_open, $file_data)
					GUICtrlSetData($edit_textToCheck, FileRead($file_data))
					$tabstate = 1
				EndIf
			Case $radio[0]
				GUICtrlSetState($input_replace, $GUI_DISABLE)
				GUICtrlSetData($input_replace, "")
				$radio_state = 0
			Case $radio[1]
				GUICtrlSetState($input_replace, $GUI_DISABLE)
				GUICtrlSetData($input_replace, "")
				$radio_state = 1
			Case $radio[2]
				GUICtrlSetState($input_replace, $GUI_ENABLE)
				$radio_state = 2
			Case $button_export
				Local $save_file = FileSaveDialog(_ISNPlugin_Get_langstring(32), @DesktopDir, $file_type & " file (*." & $file_type & ")"); Save file
				If $save_file <> "" Then
					If FileExists($save_file) Then
						$msgbox = MsgBox(1, $program_name, _ISNPlugin_Get_langstring(33) & @CRLF & _ISNPlugin_Get_langstring(34), Default, $Gui); This file already exits  Do you want to overwrite this file?
						If $msgbox = 1 Then
							FileDelete($save_file)
						EndIf
					Else
						$msgbox = 1
					EndIf
					If $msgbox = 1 Then
						IniWrite($save_file, "Website", "URL", GUICtrlRead($input_website))
						IniWrite($save_file, "Website", "POST", GUICtrlRead($input_website_post))

						IniWrite($save_file, "File", "File name", GUICtrlRead($input_file_open))

						IniWrite($save_file, "Regular expression", "Regex", GUICtrlRead($input_regex))
						IniWrite($save_file, "Regular expression", "Replace", GUICtrlRead($input_replace))
						IniWrite($save_file, "Regular expression", "Choice", $radio_state)
						IniWrite($save_file, "Text", "text", GUICtrlRead($edit_textToCheck))
						MsgBox(0, $program_name, _ISNPlugin_Get_langstring(35), 2, $Gui); Settings are saved
					EndIf	
				EndIf
			Case $button_import
				Local $open_file = FileOpenDialog(_ISNPlugin_Get_langstring(31), @DesktopDir, $file_type & " file (*." & $file_type & ")"); Load file
				If $open_file <> "" Then
					_Import($open_file, $gui)
				EndIf
			Case $GUI_EVENT_CLOSE
				Exit
		EndSwitch

		If GUICtrlRead($input_regex) <> $check_regex Or GUICtrlRead($input_website) <> $check_www Or GUICtrlRead($edit_textToCheck) <> $ChecktextToCheck Or $radio_state <> $radio_state_check Or GUICtrlRead($input_replace) <> $check_replace Then
			GUICtrlSetData($edit_matches, '')
			If GUICtrlRead($input_regex) <> "" Then
				_GUICtrlEdit_BeginUpdate($edit_matches)
				Switch $radio_state
					Case 0
						$resultHolder = StringRegExp(GUICtrlRead($edit_textToCheck), GUICtrlRead($input_regex), 0)
						If $resultHolder = 1 Then
							_GUICtrlEdit_AppendText($edit_matches, "True")
						Else
							_GUICtrlEdit_AppendText($edit_matches, "False")
						EndIf
						GUICtrlSetData($label_found, _ISNPlugin_Get_langstring(21))
					Case 1
						$resultHolder = StringRegExp(GUICtrlRead($edit_textToCheck), GUICtrlRead($input_regex), 3)
						For $i = 0 To UBound($resultHolder) - 1
							_GUICtrlEdit_AppendText($edit_matches, $resultHolder[$i] & @CRLF)
						Next
						GUICtrlSetData($label_found, _ISNPlugin_Get_langstring(21) & " (" & $i & ")"); Regex Toolkit plugin is made by Nend Software
					Case 2
						_GUICtrlEdit_AppendText($edit_matches, StringRegExpReplace(GUICtrlRead($edit_textToCheck), GUICtrlRead($input_regex), GUICtrlRead($input_replace)))
				EndSwitch
				_GUICtrlEdit_EndUpdate($edit_matches)
			EndIf
			If GUICtrlRead($edit_textToCheck) <> "" Then
				GUICtrlSetData($label_Output, _ISNPlugin_Get_langstring(20) & " (" & _ISNPlugin_Get_langstring(36) & " " & @HOUR & ":" & @MIN & ":" & @SEC & ")"); Text data  update time
			Else
				GUICtrlSetData($label_Output, _ISNPlugin_Get_langstring(20)); Text data
			EndIf
			$check_regex = GUICtrlRead($input_regex)
			$check_www = GUICtrlRead($input_website)
			$ChecktextToCheck = GUICtrlRead($edit_textToCheck)
			$check_replace = GUICtrlRead($input_replace)
			$radio_state_check = $radio_state
		EndIf

		If GUICtrlRead($input_website) <> "" Then
			If GUICtrlRead($input_website) <> $webinput Or GUICtrlRead($input_website_post) <> $postinput Then
				If StringInStr(GUICtrlRead($input_website), ".") Then
					GUICtrlSetData($edit_textToCheck, _Post_send(GUICtrlRead($input_website), GUICtrlRead($input_website_post)))
					$webinput = GUICtrlRead($input_website)
					$postinput = GUICtrlRead($input_website_post)
					$tabstate = 0
				EndIf
			EndIf
		EndIf
	WEnd
EndFunc

Func _Generate_code()
	Local $show_code
	If GUICtrlRead($edit_textToCheck) <> "" And GUICtrlRead($edit_matches) <> "" Then
		If GUICtrlRead($input_website) = "" And GUICtrlRead($input_file_open) = "" Then
			Switch $radio_state
					Case 0 
						$show_code = 'Local $return = StringRegExp("' & GUICtrlRead($edit_textToCheck) & '", "' & GUICtrlRead($input_regex) & '", 0)' & @CRLF & @CRLF & _
									 'If $return Then' & @CRLF & _
									 '	Consolewrite("Regulair Expression is a match")' & @CRLF & _
									 'Else' & @CRLF & _
									 '	Consolewrite("Regulair Expression is not a match")' & @CRLF & _
									 'EndIf'
					Case 1
						$show_code = '#include <Array.au3>' & @CRLF & @CRLF & _
									 'Local $array = StringRegExp("' & GUICtrlRead($edit_textToCheck) & '", "' & GUICtrlRead($input_regex) & '", 3)' & @CRLF & _
									 '_ArrayDisplay($array)'
					Case 2
						$show_code = 'Local $return = StringRegExpReplace("' & GUICtrlRead($edit_textToCheck) & '", "' & GUICtrlRead($input_regex) & '", "' & GUICtrlRead($input_replace) & '")' & @CRLF & _
									 'Consolewrite($return & @CRLF)'
				EndSwitch				
		Else
			Switch $tabstate
			Case 0
				Switch $radio_state
					Case 0
						$show_code = 'Local $oHTTP = ObjCreate("winhttp.winhttprequest.5.1")' & @CRLF & _
									 'If Not @error Then' & @CRLF & _
									 '	$oHTTP.Open("POST", "' & GUICtrlRead($input_website) & '")' & @CRLF & _
									 '	$oHTTP.SetRequestHeader("Content-Type", "application/x-www-form-urlencoded")' & @CRLF & _
									 '	$oHTTP.Send("' & GUICtrlRead($input_website_post) & '")' & @CRLF & @CRLF & _
									 '	Local $return = StringRegExp($oHTTP.ResponseText, "' & GUICtrlRead($input_regex) & '", 0)' & @CRLF & @CRLF & _
									 '	If $return Then' & @CRLF & _
									 '		Consolewrite("Regulair Expression is a match")' & @CRLF & _
									 '	Else' & @CRLF & _
									 '		Consolewrite("Regulair Expression is not a match")' & @CRLF & _
									 '	EndIf' & @CRLF & _
									 'EndIf'
									
					Case 1
						$show_code = '#include <Array.au3>' & @CRLF & @CRLF & _
									 'Local $oHTTP = ObjCreate("winhttp.winhttprequest.5.1")' & @CRLF & _
									 'If Not @error Then' & @CRLF & _
									 '	$oHTTP.Open("POST", "' & GUICtrlRead($input_website) & '")' & @CRLF & _
									 '	$oHTTP.SetRequestHeader("Content-Type", "application/x-www-form-urlencoded")' & @CRLF & _
									 '	$oHTTP.Send("' & GUICtrlRead($input_website_post) & '")' & @CRLF & @CRLF & _
									 '	Local $array = StringRegExp($oHTTP.ResponseText, "' & GUICtrlRead($input_regex) & '", 3)' & @CRLF & _
									 '	_ArrayDisplay($array)' & @CRLF & _
									 'EndIf'
									
					Case 2
						$show_code = 'Local $oHTTP = ObjCreate("winhttp.winhttprequest.5.1")' & @CRLF & _
									 'If Not @error Then' & @CRLF & _
									 '	$oHTTP.Open("POST", "' & GUICtrlRead($input_website) & '")' & @CRLF & _
									 '	$oHTTP.SetRequestHeader("Content-Type", "application/x-www-form-urlencoded")' & @CRLF & _
									 '	$oHTTP.Send("' & GUICtrlRead($input_website_post) & '")' & @CRLF  & @CRLF & _	
									 '	Local $return = StringRegExpReplace($oHTTP.ResponseText, "' & GUICtrlRead($input_regex) & '", "' & GUICtrlRead($input_replace) & '")' & @CRLF & _
									 '	Consolewrite($return & @CRLF)' & @CRLF & _
									 'EndIf'	
				EndSwitch			
			Case 1
				Switch $radio_state
					Case 0
						$show_code = 'Local $hfile = FileOpen("' & GUICtrlRead($input_file_open) & '", 0)' & @CRLF & _
									 'Local $file = FileRead($hfile)' & @CRLF & @CRLF & _
									 'Local $return = StringRegExp($file, "' & GUICtrlRead($input_regex) & '", 0)' & @CRLF & @CRLF & _
									 'If $return Then' & @CRLF & _
									 '	Consolewrite("Regulair Expression is a match")' & @CRLF & _
									 'Else' & @CRLF & _
									 '	Consolewrite("Regulair Expression is not a match")' & @CRLF & _
									 'EndIf' & @CRLF & @CRLF
					Case 1
						$show_code = '#include <Array.au3>' & @CRLF & @CRLF & _
									 'Local $hfile = FileOpen("' & GUICtrlRead($input_file_open) & '", 0)' & @CRLF & _
									 'Local $file = FileRead($hfile)' & @CRLF & @CRLF & _
									 'Local $array = StringRegExp($file, "' & GUICtrlRead($input_regex) & '", 3)' & @CRLF & _
									 '_ArrayDisplay($array)' & @CRLF & @CRLF
					Case 2
						$show_code = 'Local $hfile = FileOpen("' & GUICtrlRead($input_file_open) & '", 0)' & @CRLF & _
									 'Local $file = FileRead($hfile)' & @CRLF & @CRLF & _
									 'Local $return = StringRegExpReplace($file, "' & GUICtrlRead($input_regex) & '", "' & GUICtrlRead($input_replace) & '")' & @CRLF & _
									 'Consolewrite($return & @CRLF)' & @CRLF & @CRLF
				EndSwitch
				$show_code = $show_code & 'FileClose($hfile)'
			EndSwitch
		EndIf
		_ISNPlugin_Show_AutoIt_Code_Window($Code_Window_Show_Code_Only, "Autoit Code - Regex Toolkit", "", $show_code)	
	EndIf	
EndFunc

Func _Import($file, $gui_handle)
	If FileExists($file) Then
		GUICtrlSetData($input_regex, IniRead($file, "Regular expression", "Regex", ""))
		GUICtrlSetData($input_replace, IniRead($file, "Regular expression", "Replace", ""))
		Switch IniRead($file, "Regular expression", "Choice", "")
			Case 0
				$radio_state = 0
				GUICtrlSetState($radio[0], $GUI_CHECKED)
				GUICtrlSetState($input_replace, $GUI_DISABLE)
			Case 1
				$radio_state = 1
				GUICtrlSetState($radio[1], $GUI_CHECKED)
				GUICtrlSetState($input_replace, $GUI_DISABLE)
			Case 2
				$radio_state = 2
				GUICtrlSetState($radio[2], $GUI_CHECKED)
				GUICtrlSetState($input_replace, $GUI_ENABLE)
		EndSwitch

		GUICtrlSetData($input_website, IniRead($file, "Website", "URL",""))
		GUICtrlSetData($input_website_post, IniRead($file, "Website", "POST", ""))
	
		GUICtrlSetData($input_file_open, IniRead($file, "File", "File name", ""))
		GUICtrlSetData($edit_textToCheck, IniRead($file, "Text", "Text", ""))
		
		If GUICtrlRead($input_file_open) <> "" Then
			_GUICtrlTab_ActivateTab($tab, 1)
			$tabstate = 1
		Else
			$tabstate = 0
		EndIf
		
		$webinput = ""
		MsgBox(0, $program_name, _ISNPlugin_Get_langstring(39), 2, $gui_handle); Settings are loaded
	EndIf
EndFunc

Func _WM_DROPFILES_FUNC($hWnd, $msgID, $wParam, $lParam)
 	Local $nSize = DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $wParam, "int", 0, "ptr", 0, "int", 0)
	$nSize = $nSize[0] + 1
	Local $pFileName = DllStructCreate("char[" & $nSize & "]")
	DllCall("shell32.dll", "int", "DragQueryFile", "hwnd", $wParam, "int", 0, "ptr", DllStructGetPtr($pFileName), "int", $nSize)
	$gaDropFiles = DllStructGetData($pFileName, 1)
	$pFileName = 0
	_Import($gaDropFiles, $hWnd)
EndFunc

Func _GuiCtrlCreateHyperlink($s_Text, $i_Left, $i_Top, $i_Width = -1, $i_Height = -1, $i_Color = 0x0000ff, $s_ToolTip = '', $i_Style = -1, $i_ExStyle = -1)
    Local $i_CtrlID
    $i_CtrlID = GUICtrlCreateLabel($s_Text, $i_Left, $i_Top, $i_Width, $i_Height, $i_Style, $i_ExStyle)
    If $i_CtrlID <> 0 Then
		GUICtrlSetFont($i_CtrlID, $font_size, $font_weight, 4, $font_name)
		GUICtrlSetColor($i_CtrlID, $i_Color)
        GUICtrlSetCursor($i_CtrlID, 0)
        If $s_ToolTip <> '' Then
			Local $hToolTip = _GUIToolTip_Create(0)
			_GUIToolTip_AddTool($hToolTip, 0, $s_ToolTip, GUICtrlGetHandle($i_CtrlID))
        EndIf
    EndIf

    Return $i_CtrlID
EndFunc

Func _Post_send($server, $sendstring = "")
	$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")
	If Not @error Then
		$oHTTP.Open("POST", $server)
		$oHTTP.SetRequestHeader("Content-Type", "application/x-www-form-urlencoded")
		$oHTTP.Send($sendstring)
		Return($oHTTP.ResponseText)
	EndIf	
EndFunc